;****************************************************
;*	ATtiny25g153.6kHzNbNH   *
;****************************************************
;	IrDAUARTC^[tF|XIC MCP2122
;	߂̃NbNHB
;	{[[g16{̃NbNB
;	9600BPSȂ153.6kHzB
;	ATtiny25
;	  PB0 out  OC0A 153.6kHzo
;			MCP2122CLK
;	  PB1 out       gOo(500Hz)
;			mFp
;	  PB2 out  MCP2122 RESETo (LŃZbg)
;			N200ms Zbgێ
;	  PB3 -    X1	4.9152MHz Uq
;	  PB4 -    X2     V

;	Ot,  BOD=4.3V, start up14CK+64ms	
;	ZtvOL
;	Fuse  X : 0xFF
;	Fuse  H : 0xDC
;		11011100
;		|||||+++--- BOD LEVEL 4.3V
;		||||+------ EESAVE    Ȃ
;		|||+------- WDTON  EIb`hbO onȂ
;		||+-------- SPIEN  VAvO 
;		|+--------- DWEN   DebugWIRE Ȃ
;		+---------- RSTDISBL  Zbg͂
;	Fuse  L : 0xFD
;		11111101
;		||||++++--- CKSEL  3`8MHz XTAL
;		||++------- SUT    slowup 64ms
;		|+--------- CKOUT  NbNo Ȃ
;		+---------- CKDIV8 1/1
;	2022-06-26	AZuō蒼
;		27	Zbg^C~O
;***** 	CN[ht@C	*****
.include "tn25def.inc"		;ATMEL̃c[

;****************************************
;*	}@N@			*
;****************************************
;	wordf[^̏ꍇ,LSB擪oCgƂȂ
;	elm-chańgAVR.inchQl
.LISTMAC			;}NWJXg

;*****	yAWX^ւ̒lZbg	*****
.MACRO	LDIW
	LDI	@0L,  low(@1)
	LDI	@0H, high(@1)
.ENDMACRO
;*****	yAWX^Ԃ̑Z		*****
.MACRO	ADDW
	ADD	@0L, @1L
	ADC	@0H, @1H
.ENDMACRO
;*****	yAWX^Ԃ̈Z		*****
.MACRO	SUBW
	SUB	@0L, @1L
	SBC	@0H, @1H
.ENDMACRO
;*****	yAWX^Ԃ̔r		*****
;	    NE,EQ̔fł
.MACRO	CMPW
	CP	@0H,@1H		;MSB
	BRNE	PC+2		;NEȂ召ł
	CP	@0L,@1L		;EQȂ炠ƂLSB
.ENDMACRO
;	 ́r@
;		cp	@0L,@1L
;		cpc	@0H,@1H
;	0x1234 - 0x1213 ̈vr~X
	
;*****	yAWX^ւ̒lZ	*****
.MACRO	ADDIW
	SUBI	@0L,  low(-(@1))
	SBCI	@0H, high(-(@1))
.ENDMACRO
;*****	yAWX^ւ̒lZ	*****
.MACRO	SUBIW
	SUBI	@0L,  low(@1)
	SBCI	@0H, high(@1)
.ENDMACRO
;*****	yAWX^̒lr		*****
;	    NE,EQ̔fł
.MACRO	CMPIW
	CPI	@0H, high(@1)	;MSB
	BRNE	PC+2		;NEȂ召ł
	CPI	@0L,  low(@1)	;LSB
.ENDMACRO
;*****	yAWX^̃Rs[	*****
.MACRO	COPYW
	MOVW	@0H:@0L, @1H:@1L	;MOVW H:L𗪂ċLq
.ENDMACRO

;****************************************
;*	h^n@}@N@		*
;****************************************
;*****	|[go	*****
.MACRO	RESET_H
	SBI	PORTB, 2	;PB2 H
.ENDMACRO

.MACRO	RESET_L
	CBI	PORTB, 2	;PB2 L
.ENDMACRO

.MACRO	PB1_X
	SBI	PINB, 1		;PB1 gO
.ENDMACRO

;****************************************
;*	WX^̎w			*
;****************************************
;	R0LPM߂Ŏgp
;	R16`R31LDI,CPI߂g
;	R16`R23 : A,B,C,DyAWX^\
;	R26`31X,Y,Z|C^Ƃ16bitANZX
;	@@R26,27:XL,XH  R28,29:YL,YH  R30,31:ZL,ZH
;*****	f[^		*****
				;R0`R15gp
;*****	ėpWX^	*****
;	LDI,CPI߂g
;	16bitŃyAWX^ƂȂ悤ɔzu
.def	AL	= R16		;Reg A
.def	AH	= R17
.def	BL	= R18		;Reg B
.def	BH	= R19
.def	CL	= R20		;Reg C
.def	CH	= R21
;	1ms^C}[f[^
.def	TM_1L	= R22
.def	TM_1H	= R23
				;R24`R25gp
;*****	X,Y,Zڼ޽	*****
;	R26`31X,Y,Z|C^ƂăANZX
#if 0			;"tn13Adef.inc"Œ`ς
.def	XL	= R26
.def	XH	= R27
.def	YL	= R28
.def	YH	= R29
.def	ZL	= R30
.def	ZH	= R31
#endif

;****************************************
;*	rq`lGA	@		*
;****************************************
;	SRAM GA (0x0060`0x00DF) 128oCg
	.dseg			;DATA segment
	.org	SRAM_START	;RAM JnAhX

;****************************************
;*	xNgGA	@		*
;****************************************
;*****	Interrupt Vectors ****
	.cseg			;CODE segment
	.org 0
;	RJMP	INIT		;0  Reset
;	荞݂͎gȂ̂ŁAȂ菉R[hn߂
;*****			*****
INIT:
	CLI				;荞݋֎~
	LDI	AL, low(RAMEND)		;RAM ŏIAhX
	OUT	SPL, AL			;X^bN|C^ݒ
;	|[gݒ
	LDI	AL, 0b00000000		;PB data/pull up
	LDI	AH, 0b00000111		;out/in
	;	         ||||+---- PB0 out  (MOSI) OC0A 153.6kHzo
	;	         |||+----- PB1 out  (MISO) gOo(500Hz)
	;	         ||+------ PB2 out  (SCK)  MCP2122 RESETo(LŃZbg)
	;	         |+------- PB3 -    X1
	;	         +-------- PB4 -    X3
	OUT	PORTB, AL
	OUT	DDRB,  AH
;	^C}[0
	LDI	AL, 0b01000010;
	;             ||||  ++---- WGM01,00 CTC OCRA0
	;             ||++-------- COM0B (port)
	;             ++---------- COM0A1,0A0 RyA}b`ŃgO 
	OUT	TCCR0A, AL
	LDI	AL, 0b00000001
	;	          |+++--- CLK/1 4.9152MHz
	;	          +------ WGM02
	OUT	TCCR0B, AL
	LDI	AL, 16-1		;4.9152MHz / 16 / 2 = 153.6kHz 
	OUT	OCR0A, AL

;****	NbN	****
CLK1:
	RESET_L				;MCP2122ւ̃Zbgo

	LDI	CL,50			;50msԃZbgL
CLK11:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	DEC	CL
	BRNE	CLK11			;loop

	RESET_H				;MCP2122ւ̃Zbg
	LDI	CL,50			;50ms
CLK12:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	DEC	CL
	BRNE	CLK12			;loop

;	ǃZbgL
	RESET_L				;MCP2122ւ̃Zbgo
	LDI	CL,200			;200ms
CLK13:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	DEC	CL
	BRNE	CLK13			;loop
;	قƂ̃Zbg
	RESET_H				;MCP2122ւ̃Zbg
CLK14:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	RJMP	CLK14			;loop





#if 0

	LDIW	X,50			;50msԃZbgL
CLK31:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	SBIW	XH:XL, 1		;-1
	BRNE	CLK31			;loop
;	قƂ̃Zbg
	RESET_H				;MCP2122ւ̃Zbg
CLK32:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	RJMP	CLK32			;loop





	LDI	CL,200			;200msԃZbgL
CLK11:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	DEC	CL
	BRNE	CLK11			;loop
;	قƂ̃Zbg
	RESET_H				;MCP2122ւ̃Zbg
CLK24:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	RJMP	CLK24			;loop




;	񃊃Zbg 10msH
	RESET_H				;MCP2122ւ̃Zbg
	LDI	CL,10			;10ms
CLK12:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	DEC	CL
	BRNE	CLK12			;loop
;	ǃZbgL
	RESET_L				;MCP2122ւ̃Zbgo
	LDI	CL,100			;100ms
CLK13:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	DEC	CL
	BRNE	CLK13			;loop
;	قƂ̃Zbg
	RESET_H				;MCP2122ւ̃Zbg
CLK14:
	RCALL	TM1MS			;1ms҂
	PB1_X				;PB1gO(500Hz)
	RJMP	CLK14			;loop
#endif


;****************************************
;	Tu[`			*
;****************************************
;*****	1msԑ҂^C}[	*****
;	4.9154MHz/1kHz = 4915
;	4915 / 4clk    = 1229
TM1MS:
	LDIW	TM_1, 1229-8	;loop JE^
				;LDI(1+1) CALL(2) RET(4)
TM1MS1:
	SUBIW	TM_1, 1		;-1      (2)
	BRNE	TM1MS1		;X loop  (2)
	RET

;/////	end of "IRDA_TN25_1.ASM"	/////
