;****************************************************
;*	ATtiny13Ag153.6kHzNbNH   *
;****************************************************
;	IrDAUARTC^[tF|XIC MCP2122
;	߂̃NbNHB
;	{[[g16{̃NbNB
;	9600BPSȂ153.6kHzB
;	ATtiny13A
;	  PB0 out  OC0A 153.6kHzo
;			MCP2122CLK
;	  PB1 in   INT0 GbW
;			N1kHz`gĂ
;			NbNgs
;	  PB2 out  MCP2122 RESETo (LŃZbg)
;			N200ms Zbgێ
;	  PB3 in   OSCCALݒ
;			off(H)ȂZlOSCCALݒ
;			on (L)ȂHo׎̂܂܂
;	  PB4 out  gOo(500Hz)
;			mFp
;	NbN 9.6MHzgpB
;	9.6Mzx[XȂ̂Ō덷B
;	9.6MHz/62 = 154.84kHz (0.8%gj
;	ŃNbN9.8304MHzɂB
;	1/64153.6kHz𓾂B
;	Z@
;	@O1kHzNbNĂ̎𑪒B
;	@OSCCALlςȂ߂lTB
;	9.6MHzNbN, BOD=4.3V, start up14CK+64ms	
;	ZtvOL
;	Fuse  H : 0xE9
;		11101001
;		   ||||+--- RSTDISBL  Zbg͂
;		   ||++---- BOD LEVEL 4.3V
;		   |+------ DWEN      Ȃ
;		   +------- SELFPGM   ZtvO
;	      L : 0x7A
;		01111010
;		||||||++--- CKSEL  9.6MHzNbN
;		||||++----- SUT    slowup Vcc 64ms
;		|||+------- CKDIV8 1/1
;		||+-------- WDTON  Ȃ
;		|+--------- EESAV  Ȃ
;		+---------- SPIEN  SPI
;	2022-06-25	tbVROMւ݂̏
;;	        26	ƕύX "IRDA_X16_1A.ASM" 
;***** 	CN[ht@C	*****
.include "tn13Adef.inc"		;ATMEL̃c[

;****************************************
;*	}@N@			*
;****************************************
;	wordf[^̏ꍇ,LSB擪oCgƂȂ
;	elm-chańgAVR.inchQl
.LISTMAC			;}NWJXg

;*****	yAWX^ւ̒lZbg	*****
.MACRO	LDIW
	LDI	@0L,  low(@1)
	LDI	@0H, high(@1)
.ENDMACRO
;*****	yAWX^Ԃ̑Z		*****
.MACRO	ADDW
	ADD	@0L, @1L
	ADC	@0H, @1H
.ENDMACRO
;*****	yAWX^Ԃ̈Z		*****
.MACRO	SUBW
	SUB	@0L, @1L
	SBC	@0H, @1H
.ENDMACRO
;*****	yAWX^Ԃ̔r		*****
;	    NE,EQ̔fł
.MACRO	CMPW
	CP	@0H,@1H		;MSB
	BRNE	PC+2		;NEȂ召ł
	CP	@0L,@1L		;EQȂ炠ƂLSB
.ENDMACRO
;	 ́r@
;		cp	@0L,@1L
;		cpc	@0H,@1H
;	0x1234 - 0x1213 ̈vr~X
	
;*****	yAWX^ւ̒lZ	*****
.MACRO	ADDIW
	SUBI	@0L,  low(-(@1))
	SBCI	@0H, high(-(@1))
.ENDMACRO
;*****	yAWX^ւ̒lZ	*****
.MACRO	SUBIW
	SUBI	@0L,  low(@1)
	SBCI	@0H, high(@1)
.ENDMACRO
;*****	yAWX^̒lr		*****
;	    NE,EQ̔fł
.MACRO	CMPIW
	CPI	@0H, high(@1)	;MSB
	BRNE	PC+2		;NEȂ召ł
	CPI	@0L,  low(@1)	;LSB
.ENDMACRO
;*****	yAWX^̃Rs[	*****
.MACRO	COPYW
	MOVW	@0H:@0L, @1H:@1L	;MOVW H:L𗪂ċLq
.ENDMACRO

;****************************************
;*	h^n@}@N@		*
;****************************************
;*****	|[go	*****
.MACRO	RESET_H
	SBI	PORTB, 2	;PB2 H
.ENDMACRO

.MACRO	RESET_L
	CBI	PORTB, 2	;PB2 L
.ENDMACRO

.MACRO	PB4_X
	SBI	PINB, 4		;PB4 gO
.ENDMACRO

.MACRO	CK_INTF0		;INT0 GbWŃI
	IN	AL, GIFR
	ANDI	AL, 1 << INTF0
.ENDMACRO

.MACRO	CLR_INTF0		;tOINTF0NA
	LDI	AL, 1 << INTF0
	OUT	GIFR, AL
.ENDMACRO
;*****	f[^w	*****
.equ	SW_OSKIP	= 3		;PINB3LȂOSCCALւ̐ݒXLbv
.equ	CYC_1MS		= (9830 / 7)	;1ms(1kHz)JEg̃TCN
					;loop̃TCNNbN7
					;9.8304MHz/1000=9830NbN
;****************************************
;*	WX^̎w			*
;****************************************
;	R0LPM߂Ŏgp
;	R16`R31LDI,CPI߂g
;	R16`R23 : A,B,C,DyAWX^\
;	R26`31X,Y,Z|C^Ƃ16bitANZX
;	@@R26,27:XL,XH  R28,29:YL,YH  R30,31:ZL,ZH
;*****	f[^		*****
.def	OSC_H	= R10		;ZgoƂOSCCALl
				;CNT_Ho̒l
.def	OSC_CAL	= R11		;NOSCCALlǂݏo
				;1kHzZs̎͂̒lɖ߂
.def	CNT_LL	= R12		;1kHz`FbNJE^ L
.def	CNT_LH	= R13		;vOROMɋL^
.def	CNT_HL	= R14		;1kHz`FbNJE^ H
.def	CNT_HH	= R15
;*****	ėpWX^	*****
;	LDI,CPI߂g
;	16bitŃyAWX^ƂȂ悤ɔzu
.def	AL	= R16		;Reg A
.def	AH	= R17
.def	BL	= R18		;Reg B
.def	BH	= R19
.def	CL	= R20		;Reg C
.def	CH	= R21
;	1ms^C}[f[^
.def	TM_L	= R22
.def	TM_H	= R23
				;R24`R25gp
;*****	X,Y,Zڼ޽	*****
;	R26`31X,Y,Z|C^ƂăANZX
#if 0			;"tn13Adef.inc"Œ`ς
.def	XL	= R26
.def	XH	= R27
.def	YL	= R28
.def	YH	= R29
.def	ZL	= R30
.def	ZH	= R31
#endif

;****************************************
;*	rq`lGA	@		*
;****************************************
;	SRAM GA (0x0060`0x009F) 64oCg
	.dseg			;DATA segment
	.org	SRAM_START	;RAM JnAhX

;*	vOǂݏobt@
;	ROMGA 0x01F`0x01FFɏ
.equ	PGM_BFF	= SRAM_START	;1y[W32oCg
CAL_DATA:	.byte	1	;CAL_1KHZf[^
		.byte	1	;CNT_H̎CALOSCf[^
		.byte	1	;Ho׎CALf[^
		.byte	1	;00
		.byte	2	;1kHz`FbNJE^ L
		.byte	2	;1kHz`FbNJE^ H
		.byte 	24	;c̓vOƓt

;****************************************
;*	xNgGA	@		*
;****************************************
;*****	Interrupt Vectors ****
	.cseg			;CODE segment
	.org 0
;	RJMP	INIT		;0  Reset
;	荞݂͎gȂ̂ŁAȂ菉R[hn߂
;*****			*****
INIT:
	CLI				;荞݋֎~
	LDI	AL, low(RAMEND)		;RAM ŏIAhX
	OUT	SPL, AL			;X^bN|C^ݒ
;	|[gݒ
	LDI	AL, 0b00001010		;PB data/pull up
	LDI	AH, 0b00010101		;out/in
	;	         ||||+---- PB0 out  (MOSI) OC0A 153.6kHzo
	;	         |||+----- PB1 in   (MISO) INT0 GbW 1kHzZp
	;	         ||+------ PB2 out  (SCK)  RESETo(LŃZbg)
	;	         |+------- PB3 in - (CLK1) OSCCALݒ
	;	         +-------- PB4 out   gOo(500Hz)
	OUT	PORTB, AL
	OUT	DDRB,  AH
;	OSCCAL
	IN	AL, OSCCAL		;ZbgOSCCALݒl
	MOV	OSC_CAL, AL		;Ho׎̒lƂĕۑ
	LDIW	Z, 2 * CAL_1KHZ		;1kHzłOSCCALZROMf[^
	LPM	AL,Z			;ALփ[h
	CPI	AL,0x080		;80ȏȂCALĂȂ̂
	BRSH	INIT11			;ݒ肵Ȃ
	SBIC	PINB, SW_OSKIP		;PINB3LȂݒ肵Ȃ
	OUT	OSCCAL, AL		;Ugݒ
INIT11:
;	^C}[0
	LDI	AL, 0b01000010;
	;             ||||  ++---- WGM01,00 CTC OCRA0
	;             ||++-------- COM0B (port)
	;             ++---------- COM0A1,0A0 RyA}b`ŃgO 
	OUT	TCCR0A, AL
	LDI	AL, 0b00000001
	;	          |+++--- CLK/1 = 9.6MHz9.8304MHzɍZ
	;	          +------ WGM02
	OUT	TCCR0B, AL
	LDI	AL, 32-1		;9.8304MHz / 32 / 2 = 153.6kHz 
	OUT	OCR0A, AL
;	INT0
	LDI	AL, 0b00000010
	;	       |||| ++--- ICS  GbWo
	;	       ||++------ SM1,0
	;	       |+-------- SE
	;	       +--------- PUD
	OUT	MCUCR, AL
;	INT0ɃpX͂JԂΎgZ
;	50mSԂ10猟o
	LDIW	X, 65000		;65000loop
	LDI	CL,10			;10pXJE^
INIT21:
	SBIW	XL, 1			;loop -1         (2)
	BREQ	CLK1			;          (1)
	CK_INTF0			;INT0pX? (2)
	BREQ	INIT21			;Ȃ            (2)
	CLR_INTF0			;pX
	DEC	CL			;JEg -1	
	BRNE	INIT21			;܂
	RJMP	FCAL			;UgZ

;****	NbN	****
;	1KHz̘ApXȂ
;	1kHzł̍ZI
CLK1:
	RESET_L				;MCP2122ւ̃Zbgo
	LDI	CL,200			;200msԃZbgL
CLK11:
	RCALL	TM1MS			;1ms҂
	PB4_X				;PB4gO(500Hz)
	DEC	CL
	BRNE	CLK11			;loop
;	Zbg
	RESET_H				;MCP2122ւ̃Zbg
CLK12:
	RCALL	TM1MS			;1ms҂
	PB4_X				;PB4gO(500Hz)
	RJMP	CLK12			;loop

;********************************
;*	gZ		*
;********************************
;*****	U UgZ	*****
;	1kHzpXINT0ɓ
;	GbWoă[vJE^X^[g
;	9.8304MHzߖT̃JEglOSCCALlZo
;	OSCCAL0`127 0㏸`FbN
;	9.8304MHz/1kHz = 9830
FCAL:
	LDI	CH, 0			;OSCCALl 0
;	INT0GbW҂
FCAL1:
	LDIW	X, 0			;GbWԃ[vJE^
FCAL11:
	CK_INTF0			;INT0pX?
	BRNE	FCAL12			;
	ADIW	XL, 1			;Ȃ΃JEgAbv
	BRNE	FCAL11			;loop
	RJMP	FCALER			;0ɂȂG[
FCAL12:
	CLR_INTF0			;INTF0NA
;	OSCCALlZbgĎԑ҂
	OUT	OSCCAL, CH		;gύX
	PB4_X				;PB4gO(500Hz)
	LDI	CL, 20			;20ms҂
FCAL21:
	LDIW	X, 0			;GbWԃ[vJE^
FCAL22:
	CK_INTF0			;INT0pX?
	BRNE	FCAL23			;pX҂    (2)
	ADIW	XL, 1			;JEgAbv
	BRNE	FCAL22			;loop
	RJMP	FCALER			;0ɂȂG[
FCAL23:
	CLR_INTF0			;INTF0NA    (2)
	DEC	CL			;10         (1)
	BRNE	FCAL21			;10mso?      (1)
;	́GbW܂łJEg
;	RESET_H				;(!!!)
	LDIW	X, 1			;GbWԃJE^ 1(Ocyc)
FCAL31:
	CK_INTF0			;INT0pX? (2)
	BRNE	FCAL32			;pX҂    (1)
	ADIW	XL, 1			;JEgAbv  (2)
	BRNE	FCAL31			;loop            (2)
	RJMP	FCALER			;0ɂȂG[
FCAL32:
	CLR_INTF0			;INTF0NA
;	RESET_L				;(!!!)
;	JEgl 1msł̃TCNƔr
	CMPIW	X, CYC_1MS		;9830/7 clk
	BRSH	FCAL41			;gŕ
	COPYW	Y, X			;lۑ
	COPYW	CNT_L, X		;vOROMݗpŕۑ(L)
	INC	CH			;CALl+1
	CPI	CH,128			;0`127
	BRNE	FCAL1			;
	RJMP	FCALER			;128ɂȂG[
;	Ol(Y)Ƃǂ炪߂f
FCAL41:
	MOV	OSC_H, CH		;g厞OSCCAL
	COPYW	CNT_H, X		;vOROMݗpŕۑ(H)
	LDIW	A, CYC_1MS		;A=(9830/7) - Y
	SUBW	A, Y
	SUBIW	X, CYC_1MS		;X=X - (9830/7)
	CMPW	X, A
	BRLO	FCAL42			;XCHCALl
	DEC	CH			;ACH-1
FCAL42:
	OUT	OSCCAL, CH		;gύX
;*	vOROMɌʂL^(ȃvO~O)
;	RESET_H				;(!!!)
	RCALL	RDBFF			;ROMf[^RAMɓǂݏo
	RCALL	ERSBFF			;ROMGA
;	RESET_L				;(!!!)
;	RAMɃf[^
	LDIW	Z, PGM_BFF		;RDBFFRAM̐擪
	IN	AL, OSCCAL		;ZOSCCALl(CAL_1KHZ)
	ST	Z+, AL			;CAL_DATA
	ST	Z+, OSC_H		;CAL_H   CNTHOSC_CAL
	ST	Z+, OSC_CAL		;CAL_ORG HoCALl
	CLR	AL
	ST	Z+, AL			;00
	ST	Z+, CNT_LL		;CNT_L 1kHzJEgl(L)
	ST	Z+, CNT_LH
	ST	Z+, CNT_HL		;CNT_H 1kHzJEgl(H)
	ST	Z+, CNT_HH
;	RAMobt@ɃRs[ 1[hƓ]
	RCALL	CPYBFF			;RAMf[^ɏՃobt@
;	RESET_H				;(!!!)
	RCALL	WRBFF			;ROM
;	RESET_L				;(!!!)
	RJMP	CLK1			;NbN

;*	G[
;	Ho׎OSCCALɖ߂
FCALER:
	OUT	OSCCAL, OSC_CAL		;gύX
	RJMP	CLK1			;NbN

;****************************************
;*	vOւ̃f[^ۑ	*
;****************************************
;	tbVATtiny13Ãy[WTCY32oCg
;	AhXxxx0`xxxF 16[h
;	0x01F0`0x01FFŏIy[W1kHzZOSCCALl̕ۑɎg
;	ZH,ZLɂ2{AhXݒ (2 * CAL_1KHZ)
; SPMCSR - Store Program Memory Control and Status Register
;.equ	SPMEN	= 0	; Store program Memory Enable
;.equ	PGERS	= 1	; Page Erase
;.equ	PGWRT	= 2	; Page Write
;.equ	RFLB	= 3	; Read Fuse and Lock Bits
;.equ	CTPB	= 4	; Clear Temporary Page Buffer

;*****	SPMsTu[`	*****
;	busy`FbNăR}hs
;	AL : SPMCSRւ̃R}h
;	use AH
SPMCK:
	IN	AH, SPMCSR		;ݏ
	SBRC	AH, SPMEN		;SPMEN1ɂȂ
	RJMP	SPMCK			;I܂ő҂
;	R}h
	OUT	SPMCSR, AL		;AL:R}h
	SPM				;<Store Program Memory>
	RET

;*****	vO̓ǂݏo	*****
;	CAL_1KHZf[^܂32oCg
;	ROMf[^RAMɓǂݏo
;	̌ACAL_DATAZlɕύX
RDBFF:
	LDIW	Z, 2 * CAL_1KHZ		;ROM擪	
	LDIW	Y, PGM_BFF		;RAM擪
	LDI	CL, 32			;32oCg
RDBFF1:
	LPM	R0, Z+			;ZR0
	ST	Y+, R0			;RORAMɃRs[
	DEC	CL
	BRNE	RDBFF1			;loop
	RET

;*****	vȌ	*****
;	CAL_1KHZ擪32oCg̃GA
ERSBFF:
	LDIW	Z, 2 * CAL_1KHZ		;ROM擪	
	LDI	AL, (1 << PGERS) + (1 << SPMEN)	;R}h
	RCALL	SPMCK			;busy`FbNɏ
	RET

;*****	RAMf[^vO֓] *****
;	CAL_1KHZ擪32oCg̃GA
;	1[hƂɃRs[
CPYBFF:
	LDIW	Z, 2 * CAL_1KHZ		;ROM擪	
	LDIW	Y, PGM_BFF		;RAM擪
	LDI	CL, 16			;16[h(32oCg)
CPYBFF1:
	LD	R0, Y+			;RAM
	LD	R1, Y+			;R1,R0
	LDI	AL, 1 << SPMEN		;ɏՕւ̏
	RCALL	SPMCK			;busy`FbNɏ
	ADIW	ZL, 2			;Z +2
	DEC	CL
	BRNE	CPYBFF1			;loop
	RET

;*****	vȌ	*****
;	CAL_1KHZf[^XV
WRBFF:
	LDIW	Z, 2 * CAL_1KHZ		;ROM擪	
	LDI	AL, (1 << PGWRT) + (1 << SPMEN)	;݃R}h
	RCALL	SPMCK			;busy`FbNɏ
	RET

;****************************************
;	Tu[`			*
;****************************************
;*****	1msԑ҂^C}[	*****
;	9.8304MHz/1kHz = 9830
;	9830 / 4clk    = 2457
TM1MS:
	LDIW	TM_, 2457-8	;loop JE^
				;LDI(1+1) CALL(2) RET(4)
TM1MS1:
	SUBIW	TM_, 1		;-1      (2)
	BRNE	TM1MS1		;X loop  (2)
	RET

;****************************************
;	ROMy[Wf[^			*
;****************************************
;*****	OSC CALf[^	*****
;	1kHzōZlۑ  PGM_BFFRs[
	.ORG	0x01F0
CAL_1KHZ:
	.db	0x0FF, 0x0FF	; 0 1kHzZf[^ۑ OSCCALփRs[
	.db	0x0FF, 0x0FF	; 2 Ho׎OSCCALlu
	.dw	0x0FFFF		; 4 1kHz cal CNT_L
	.dw	0x0FFFF		; 6 1kHz cal CNT_H
	.dw	0		; 8
	.db	"IRDA_X16_1A "	;10
	.db	"2022-06-26"	;22
	;	 012345678901
;	0x01F0`0x01FF tbV݂ċL^

;/////	end of "IRDA_X16_1A.ASM"	/////

